import { PersistentModel, PersistentModelConstructor, PersistentModelMetaData, IdentifierFieldOrIdentifierObject } from '@aws-amplify/datastore';
export interface UseDataStoreDeleteActionOptions<Model extends PersistentModel> {
    model: PersistentModelConstructor<Model>;
    id: IdentifierFieldOrIdentifierObject<Model, PersistentModelMetaData<Model>>;
}
/**
 * Action to Delete DataStore item
 * @internal
 */
export declare const useDataStoreDeleteAction: <Model extends Readonly<Record<string, any>>>({ model, id }: UseDataStoreDeleteActionOptions<Model>) => (() => Promise<void>);
export declare const useDataStoreDeleteActionString = "export const useDataStoreDeleteAction =\n<Model extends PersistentModel>({\n  model,\n  id,\n}: UseDataStoreDeleteActionOptions<Model>): (() => Promise<void>) =>\nasync () => {\n  try {\n    Hub.dispatch(\n      UI_CHANNEL,\n      {\n        event: ACTION_DATASTORE_DELETE_STARTED,\n        data: { id },\n      },\n      EVENT_ACTION_DATASTORE_DELETE,\n      AMPLIFY_SYMBOL\n    );\n\n    await DataStore.delete(model, id);\n\n    Hub.dispatch(\n      UI_CHANNEL,\n      {\n        event: ACTION_DATASTORE_DELETE_FINISHED,\n        data: { id },\n      },\n      EVENT_ACTION_DATASTORE_DELETE,\n      AMPLIFY_SYMBOL\n    );\n  } catch (error) {\n    Hub.dispatch(\n      UI_CHANNEL,\n      {\n        event: ACTION_DATASTORE_DELETE_FINISHED,\n        data: { id, errorMessage: getErrorMessage(error) },\n      },\n      EVENT_ACTION_DATASTORE_DELETE,\n      AMPLIFY_SYMBOL\n    );\n  }\n};";
