"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStateMutationActionString = exports.useStateMutationAction = void 0;
/*
  Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.

  Licensed under the Apache License, Version 2.0 (the "License").
  You may not use this file except in compliance with the License.
  You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
const React = __importStar(require("react"));
const aws_amplify_1 = require("aws-amplify");
const constants_1 = require("./constants");
const amplify_symbol_1 = require("../amplify-symbol");
/**
 * Action to wrap React.useState with Hub events
 * @internal
 */
const useStateMutationAction = (initialState) => {
    const [state, setState] = React.useState(initialState);
    const setNewState = React.useCallback((newState) => {
        const prevState = state;
        aws_amplify_1.Hub.dispatch(constants_1.UI_CHANNEL, {
            event: constants_1.ACTION_STATE_MUTATION_STARTED,
            data: { prevState, newState },
        }, constants_1.EVENT_ACTION_CORE_STATE_MUTATION, amplify_symbol_1.AMPLIFY_SYMBOL);
        setState(newState);
        aws_amplify_1.Hub.dispatch(constants_1.UI_CHANNEL, {
            event: constants_1.ACTION_STATE_MUTATION_FINISHED,
            data: { prevState, newState },
        }, constants_1.EVENT_ACTION_CORE_STATE_MUTATION, amplify_symbol_1.AMPLIFY_SYMBOL);
    }, [state]);
    return [state, setNewState];
};
exports.useStateMutationAction = useStateMutationAction;
exports.useStateMutationActionString = `export const useStateMutationAction = (initialState) => {
  const [state, setState] = React.useState(initialState);

  const setNewState = React.useCallback(
    (newState) => {
      const prevState = state;

      Hub.dispatch(
        UI_CHANNEL,
        {
          event: ACTION_STATE_MUTATION_STARTED,
          data: { prevState, newState },
        },
        EVENT_ACTION_CORE_STATE_MUTATION,
        AMPLIFY_SYMBOL,
      );

      setState(newState);

      Hub.dispatch(
        UI_CHANNEL,
        {
          event: ACTION_STATE_MUTATION_FINISHED,
          data: { prevState, newState },
        },
        EVENT_ACTION_CORE_STATE_MUTATION,
        AMPLIFY_SYMBOL,
      );
    },
    [state],
  );

  return [state, setNewState];
};`;
//# sourceMappingURL=useStateMutationAction.js.map